package com.loafle.overflow.model.target;

import javax.persistence.*;

import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.sensor.Sensor;

import java.util.Date;
import java.util.List;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "TARGET", schema = "public")
public class Target {

    private Long id;
    private Date createDate;
    private String displayName;
    private String description;
    private Integer sensorCount;
    private Infra infra;

    // Transient property
    private List<Sensor> sensors;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    @Temporal(TemporalType.TIMESTAMP)
    @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    @Column(name = "DISPLAY_NAME")
    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    @Column(name = "DESCRIPTION")
    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    @Column(name = "SENSOR_COUNT", nullable = false)
    public Integer getSensorCount() {
        return sensorCount;
    }

    public void setSensorCount(Integer sensorCount) {
        this.sensorCount = sensorCount;
    }

    @Transient
    public List<Sensor> getSensors() {
        return sensors;
    }

    public void setSensors(List<Sensor> sensors) {
        this.sensors = sensors;
    }

    @PrePersist
    void preInsert() {
        this.sensorCount = 0;
    }

    @OneToOne
    @JoinColumn(name = "INFRA_ID", nullable = false)
    public Infra getInfra() {
        return infra;
    }

    /**
     * @param infra the infra to set
     */
    public void setInfra(Infra infra) {
        this.infra = infra;
    }

    // @ManyToOne
    // @JoinColumn(name = "PROBE_ID", nullable = false)
    // @OnDelete(action = OnDeleteAction.CASCADE)
    // public Probe getProbe() {
    // return probe;
    // }
    //
    // public void setProbe(Probe probe) {
    // this.probe = probe;
    // }
    //
    // @ManyToOne
    // @JoinColumn(name = "INFRA_ID", nullable = false)
    // public Infra getInfra() {
    // return infra;
    // }
    //
    // public void setInfra(Infra infra) {
    // this.infra = infra;
    // }

}
