package com.loafle.overflow.service.central.probe;

import com.loafle.overflow.core.annotation.ProbeAPI;
import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.probe.Probe;

import java.util.List;

/**
 * Created by snoop on 17. 6. 28.
 */
public interface ProbeService {

  Probe regist(Probe probe) throws OverflowException;

  @WebappAPI
  List<Probe> readAllByDomainID(Long id) throws OverflowException;

  @WebappAPI
  Probe read(Long id) throws OverflowException;

  @WebappAPI 
  Probe modify(Probe probe) throws OverflowException;

  @ProbeAPI
  void onConnect(String probeKey, String connectAddress) throws OverflowException;

  @ProbeAPI
  void onDisconnect(String probeKey) throws OverflowException;

  Probe increaseTargetCount(Long id) throws OverflowException;

  Probe decreaseTargetCount(Long id) throws OverflowException;

}
