package com.loafle.overflow.service.container;

import java.util.List;

import com.loafle.overflow.core.annotation.ProbeAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.interfaces.Service;
import com.loafle.overflow.model.sensorconfig.SensorConfig;

/**
 * SensorConfigService
 */
public interface SensorConfigService extends Service {
  @ProbeAPI
  void InitConfig(List<SensorConfig> sensorConfigs) throws OverflowException;

  @ProbeAPI
  void AddConfig(SensorConfig sensorConfig) throws OverflowException;

  @ProbeAPI
  void UpdateConfig(SensorConfig sensorConfig) throws OverflowException;

  @ProbeAPI
  void RemoveConfig(String configID) throws OverflowException;
}